/*--------------------------------------------------------
  "THE BEER-WARE LICENSE" (Revision 42):
  Alex Kostyuk wrote this code. As long as you retain this 
  notice you can do whatever you want with this stuff. 
  If we meet some day, and you think this stuff is worth it, 
  you can buy me a beer in return.
----------------------------------------------------------*/ 

#include "includes.h"


int loop = 1, keypress;
float scale_factor;
HDC hdc;
FILE *inifile;
BITMAP *scrat, *card, *adf,*vor,*ndx,*mask,*hub,*frame;
PALETTE palette;
float single_brg = 0;
float hdg = 0;
float double_brg = 0;
int single_niddle_src = 0;
int double_niddle_src = 0;
int mouse_flag = 0;


int initialise_window( void );
int update_display( void );
int create_bitmaps( void );
int act_on_keypress( void );
int close_program( void );
void exit_hook (void );


int main(int argc, char *argv[] )
{
    STARTUPINFO cif;
    PROCESS_INFORMATION pi;
    load_config();

    if(0 == strcmp(config.console,"off") && argc == 1)
    {
        ZeroMemory(&cif,sizeof(STARTUPINFO));
        if(CreateProcess(NULL,"adf.exe AS_DAEMON",
                         NULL,NULL,FALSE,CREATE_NO_WINDOW,NULL,NULL,&cif,&pi))

        {
            CloseHandle( pi.hProcess );
            CloseHandle( pi.hThread );
            exit(0);
        }
    }

    if(config.uplink_port)
        server_start(config.uplink_port);


    if(config.downlink_port)
    {
        udp_sender_start(config.downlink_port, config.downlink_ip);
    }


    initialise_window();

    printf("mouse buttons number = %d\n",install_mouse());
    show_os_cursor(2);

    if(mouse_needs_poll())
        printf("the current mouse driver is operating in polling mode\n");


    if( create_bitmaps() == -1 )
    {
        textprintf_centre(screen, font, config.size / 2, config.size * 0.15, 65535,  "*** Error ***" );
        textprintf_centre(screen, font, config.size / 2, config.size * 0.40, 65535,  "No Graphics files" );
        textprintf_centre(screen, font, config.size / 2, config.size * 0.65, 65535,  "Press Key to Exit" );
        readkey();
        close_program();
        return( -1 );
    }

    update_display();

    while( loop == 1 )
    {

        while( keypressed() )
        {
            act_on_keypress();
            update_display();
        }
        clear_keybuf();
        update_display();
    }
    save_config();
    close_program();
    return (0);
}
END_OF_MAIN()

int initialise_window( void )
{
    int screen_colour_depth;
    hdc = GetDC(NULL);
    screen_colour_depth = GetDeviceCaps (hdc, BITSPIXEL );

    if (allegro_init() != 0) return 1; //Initialise Allegro
    install_keyboard();

    set_color_depth(screen_colour_depth);


    if (set_gfx_mode(GFX_AUTODETECT_WINDOWED, 800, 600, 0, 0) != 0)
    {
        if (set_gfx_mode(GFX_SAFE, 800, 600, 0, 0) != 0)
        {
            set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
            allegro_message("Unable to set any graphic mode\n%s\n", allegro_error);
            return 1;
        }
    }

    SetWindowPos(win_get_window(), HWND_TOPMOST,
                 config.x_pos,
                 config.y_pos,
                 config.size+6,
                 config.size+25,
                 SWP_ASYNCWINDOWPOS);

    set_display_switch_mode(SWITCH_BACKGROUND);
    scale_factor = ((float)config.size / 400);

    set_window_close_hook(exit_hook);
    return( 0 );
}

int mouse_action(int mouse_state)
{
    if (mouse_state & 1)
    {
        single_niddle_src++;
        if(single_niddle_src>3)
            single_niddle_src = 0;
        return 1;

    }
    if (mouse_state & 2)
    {
        double_niddle_src++;
        if(double_niddle_src>3)
            double_niddle_src = 0;
        return 1;
    }
    return 0;
}


int update_display( void )
{
    int size = config.size;
    int mouse_state = mouse_b;
    rotate_scaled_sprite(scrat, card, 00, 00, ftofix(-hdg/1.40625) , ftofix(scale_factor));
    masked_stretch_blit( mask, scrat, 0,0,400,400,0,0,size,size);

    pivot_scaled_sprite(scrat, vor, size / 2, (size / 2), 145, 145, ftofix(double_brg/1.40625) , ftofix(scale_factor));
    pivot_scaled_sprite(scrat, adf, size / 2, (size / 2), 145, 145, ftofix(single_brg/1.40625) , ftofix(scale_factor));
    pivot_scaled_sprite(scrat, hub, size / 2, (size / 2), 125, 125, ftofix(0) , ftofix(scale_factor/5));

    rotate_scaled_sprite(scrat, ndx, size/2-round(75.0/4.0*scale_factor), 0, ftofix(0) , ftofix(scale_factor/4.0));

    rotate_scaled_sprite(scrat, frame, 00, 00, ftofix(32) , ftofix(scale_factor*0.666666666));

    if(mouse_state & 3 && mouse_flag)
    {

    }
    else if (!(mouse_state & 3) && mouse_flag)
    {
        mouse_flag = 0;
    }


    if(mouse_flag == 0)
    {
        mouse_flag = mouse_action(mouse_state);
    }

    const char *niddles_src_name[] =
    {
        "ADF1",
        "ADF2",
        "NAV1",
        "NAV2"
    };
    textprintf_ex(scrat, font, 5, 5, makecol(255, 255, 000),-1,
                  niddles_src_name[single_niddle_src]
                 );

    textprintf_ex(scrat, font, size-40, 5, makecol(000, 255, 000),-1,
                  niddles_src_name[double_niddle_src]
                 );



    blit(scrat, screen, 0, 0, 0, 0, size, size);
    Sleep(50);
    return( 0 );
}

int create_bitmaps( void )
{
    int size = config.size;
    scrat = create_bitmap(size, size);
    if( (card = load_bitmap( "..\\Resources\\adf\\card.bmp", card )) == NULL ) return( -1 );
    if( (ndx = load_bitmap( "..\\Resources\\adf\\ndx.bmp", ndx )) == NULL ) return( -1 );
    if( (adf = load_bitmap( "..\\Resources\\adf\\adf.bmp", adf )) == NULL ) return( -1 );
    if( (vor = load_bitmap( "..\\Resources\\adf\\vor.bmp", vor )) == NULL ) return( -1 );
    if( (mask = load_bitmap( "..\\Resources\\adf\\mask.bmp", mask )) == NULL ) return( -1 );
    if( (hub = load_bitmap( "..\\Resources\\adf\\hub.bmp", hub )) == NULL ) return( -1 );
    if( (frame = load_bitmap( "..\\Resources\\adf\\frame3.bmp", frame )) == NULL ) return( -1 );
    return( 0 );
}

int act_on_keypress( void )
{
    RECT rect;
    if (GetWindowRect(win_get_window(), &rect))
    {
        config.x_pos = (int)rect.left;
        config.y_pos = (int)rect.top;
    }
    keypress = readkey();
    switch (keypress)
    {
    case 6778: //z
        break;

    case 6264: //x

        break;

    case 867: //c
        hdg-=1.0;
        break;


    case 5750: //v
        hdg+=1.0;
        break;


    case 4465 : //q

        break;

    case 353: //a

        break;

    case 6007 : //w

        break;

    case 1381: //e

        break;


    case 2409:         //i pressed ( increase size )
        if ( config.size < 600 ) config.size+=1;
        destroy_bitmap( scrat );
        scrat = create_bitmap(config.size, config.size);
        SetWindowPos(win_get_window(),
                     HWND_TOPMOST,
                     config.x_pos,
                     config.y_pos,
                     config.size+6,
                     config.size+25,
                     SWP_NOZORDER);

        scale_factor = ((float)config.size / 400);
        break;

    case 1124:         //d pressed ( decrease size )
        if( config.size > 142 ) config.size-=1;
        destroy_bitmap( scrat );
        scrat = create_bitmap(config.size, config.size);
        SetWindowPos(win_get_window(),
                     0,
                     config.x_pos,
                     config.y_pos,
                     config.size+6,
                     config.size+25,
                     SWP_NOZORDER);
        scale_factor = ((float)config.size / 400);
        break;
    }
    return( 0 );
}
int close_program( void )
{
    allegro_exit();
    return( 0 );
}
void exit_hook( void )
{
    loop = 0;
}

void cb_on_data(int block_id, float *data)
{
    int i;

    switch(block_id)
    {
    case 99:
        switch(single_niddle_src)
        {
        case 0:
            break;

        case 1:
            break;

        case 2:
            single_brg = data[3];
            break;

        case 3:
            break;
        }

        switch(double_niddle_src)
        {
        case 0:
            break;

        case 1:
            break;

        case 2:
            double_brg = data[3];
            break;

        case 3:
            break;
        }

        break;


    case 100:
        switch(single_niddle_src)
        {
        case 0:
            break;

        case 1:
            break;

        case 2:
            break;

        case 3:
            single_brg = data[3];
            break;
        }

        switch(double_niddle_src)
        {
        case 0:
            break;

        case 1:
            break;

        case 2:
            break;

        case 3:
            double_brg = data[3];
            break;
        }

        break;

    case 17:
        hdg = data[3];
        break;

    case 101:

        switch(single_niddle_src)
        {
        case 0:
            single_brg = data[2];
            break;

        case 1:
            single_brg = data[6];
            break;

        case 2:
            break;

        case 3:
            break;
        }

        switch(double_niddle_src)
        {
        case 0:
            double_brg = data[2];
            break;
        case 1:
            double_brg = data[6];
            break;
        case 2:
            break;
        case 3:
            break;
        }
        break;
    }
}








