/*--------------------------------------------------------
  "THE BEER-WARE LICENSE" (Revision 42):
  Alex Kostyuk wrote this code. As long as you retain this 
  notice you can do whatever you want with this stuff. 
  If we meet some day, and you think this stuff is worth it, 
  you can buy me a beer in return.
----------------------------------------------------------*/ 

#include "includes.h"

SOCKET RecvSocket;
SOCKET SendSocket;
struct sockaddr_in RecvAddr;
void set_inputs(int dev_id, unsigned long state);
DWORD WINAPI ServerThread (LPVOID parms);
DWORD WINAPI SenderThread (LPVOID parms);
DWORD ServerThreadID, SenderThreadID;
HANDLE hServerThread,hSenderThread;
void hexdump(char *st_adr,short len);
static int server_active = 0;



DWORD WINAPI SenderThread (LPVOID parms)
{

    while(server_active)
    {
        Sleep(1000);

    }
}

int asm_float_ieee754(unsigned char *wp, float *val)
{
    unsigned char cp[4];
    cp[0] = *wp++;
    cp[1] = *wp++;
    cp[2] = *wp++;
    cp[3] = *wp++;
    *val = *((float*)cp);
    return 4;
}

void cb_on_data(int block_id, float *data);



DWORD WINAPI ServerThread (LPVOID parms)
{
    int len,block_id,i,j;
    float data[8],fltmp;
    unsigned char *p;
    struct sockaddr_in SenderAddr;
    int SenderAddrSize = sizeof(SenderAddr);
    unsigned char RecvBuf[2048];
    int  BufLen = 2048;
    unsigned long tmp_long;
    unsigned long tmp_sw_long;
    int dg_len,sender_id, data_type, data_len;
    while(server_active)
    {
        len  = recvfrom(RecvSocket,
                        RecvBuf,
                        BufLen,
                        0,
                        (SOCKADDR *)&SenderAddr,
                        &SenderAddrSize);

        /*
        44 41 54 41 40
        13 00 00 00

        12 0F 72 43
        7C BA B6 C0
        00 C0 79 C4
        00 C0 79 C4
        00 C0 79 C4
        00 C0 79 C4
        00 C0 79 C4
        00 C0 79 C4

        76 00 00 00
        00 00 C6 42
        10 9D 53 43
        00 80 ED 44
        00 00 7A C4
        00 00 00 00
        7E 58 39 44
        A6 A7 BA 3C
        9E 98 28 3E

        */


        if(len<=0) break;


        udp_send(RecvBuf,len);


        if(RecvBuf[0] == 'D' &&
                RecvBuf[1] == 'A' &&
                RecvBuf[2] == 'T' &&
                RecvBuf[3] == 'A' &&
                RecvBuf[4] == '@'
          )
        {
            len -= 5;
            p = &RecvBuf[5];
            for(i=0; len>0; i++)
            {
                block_id = *p;
                p += 4;

                for(j=0; j<8; j++)
                {
                    p += asm_float_ieee754(p, &fltmp);
                    data[j] = fltmp;
                }
                len -= 36;
                cb_on_data(block_id, data);
            }
        }

    }

}


int udp_sender_start(int Port, const char *ip)
{
    WSADATA wsaData;
    char SendBuf[2024];
    int BufLen = 2024;
    //---------------------------------------------
    // Initialize Winsock
    WSAStartup(MAKEWORD(2,2), &wsaData);

    //---------------------------------------------
    // Create a socket for sending data
    SendSocket = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    //---------------------------------------------
    // Set up the RecvAddr structure with the IP address of
    // the receiver (in this example case "123.456.789.1")
    // and the specified port number.
    RecvAddr.sin_family = AF_INET;
    RecvAddr.sin_port = htons(Port);
    RecvAddr.sin_addr.s_addr = inet_addr(ip);

    return 0;
}




int udp_sender_stop(void)
{
    closesocket(SendSocket);
    WSACleanup();
    return 0;
}


int udp_send(char *buf,int len)
{
    sendto(SendSocket,
           buf,
           len,
           0,
           (SOCKADDR *) &RecvAddr,
           sizeof(RecvAddr));
    return 0;
}


int server_start(int Port)
{
    WSADATA wsaData;
    struct sockaddr_in RecvAddr;
    struct sockaddr_in SenderAddr;
    int SenderAddrSize = sizeof(SenderAddr);
    //-----------------------------------------------
    // Initialize Winsock
    WSAStartup(MAKEWORD(2,2), &wsaData);
    //-----------------------------------------------
    // Create a receiver socket to receive datagrams
    RecvSocket = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    //-----------------------------------------------
    // Bind the socket to any address and the specified port.
    RecvAddr.sin_family = AF_INET;
    RecvAddr.sin_port = htons(Port);
    RecvAddr.sin_addr.s_addr = htonl(INADDR_ANY);

    bind(RecvSocket, (SOCKADDR *) &RecvAddr, sizeof(RecvAddr));
    server_active = 1;
    hServerThread = CreateThread(NULL, 0, ServerThread, &RecvSocket, 0, &ServerThreadID);
    if (hServerThread == INVALID_HANDLE_VALUE)
    {
        return -1;
    }
    hSenderThread = CreateThread(NULL, 0, SenderThread, NULL, 0, &SenderThreadID);
    if (hSenderThread == INVALID_HANDLE_VALUE)
    {
        return -1;
    }

    return 0;
}

int server_stop(void)
{
    server_active = 0;
    closesocket(RecvSocket);
    WSACleanup();
    return 0;
}


